apiVersion: v1
kind: Namespace
metadata:
  name: aztendance-webapp
  labels:
    app: aztendance-webapp
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: aztendance-webapp
  namespace: aztendance-webapp
  labels:
    app: aztendance-webapp
spec:
  replicas: 1
  selector:
    matchLabels:
      app: aztendance-webapp
  template:
    metadata:
      labels:
        app: aztendance-webapp
    spec:
      containers:
      - image: registry.gitlab.com/team6479/aztendance/webapp:latest
        imagePullPolicy: Always
        name: aztendance-webapp-container
        ports:
          - containerPort: 3000
---
apiVersion: v1
kind: Service
metadata:
  name: aztendance-webapp-service
  namespace: aztendance-webapp
  labels:
    app: aztendance-webapp
spec:
  selector:
    app: aztendance-webapp
  ports:
  - protocol: TCP
    port: 80
    targetPort: 3000
---
apiVersion: networking.k8s.io/v1beta1
kind: Ingress
metadata:
  name: aztendance-webapp-ingress
  namespace: aztendance-webapp
  labels:
    app: aztendance-webapp
  annotations:
    kubernetes.io/ingress.class: nginx
    nginx.ingress.kubernetes.io/enable-cors: "true"
    nginx.ingress.kubernetes.io/cors-allow-origin: "*"
    cert-manager.io/issuer: "letsencrypt"
spec:
  rules:
    - host: "aztendance.team6479.org"
      http:
        paths:
        - path: /
          pathType: Prefix
          backend:
            serviceName: aztendance-webapp-service
            servicePort: 80
  tls:
    - hosts:
        - aztendance.team6479.org
      secretName: aztendance-webapp-tls
---
apiVersion: cert-manager.io/v1
kind: Issuer
metadata:
  name: letsencrypt
  namespace: aztendance-webapp
spec:
  acme:
    server: https://acme-v02.api.letsencrypt.org/directory
    email: aztech@team6479.org
    privateKeySecretRef:
      name: letsencrypt
    solvers:
    - selector: {}
      http01:
        ingress:
          class: nginx
